package r.j;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.Writer;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Hashtable;

import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import bib.*;

public class Ra1ClieActivity extends Activity {
    String urlServ = "", pathServ = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_ra1_clie);
    }

    public void onClickExec(View view) {
        urlServ = ((EditText) findViewById(R.id.urlserv)).getText().toString();
        AsyncTask<String, Void, String> task = new AsyncTask<String, Void, String>() {

            @Override
            protected String doInBackground(String... strings) {
                String resp = "", linie = "";
                try {
                    resp += "Client: RESTful Android: " + urlServ + "\n";
                    Hashtable<String, String> uRL = Hurl.hurl(urlServ);
                    urlServ = "http://" + uRL.get("host") + ":"
                            + uRL.get("port") + "/";
                    if (uRL.get("path").length() > 0)
                        urlServ += uRL.get("path") + "/";

                    URL url = new URL(urlServ + "ping");
                    HttpURLConnection conn = (HttpURLConnection) url
                            .openConnection();
                    conn.setRequestMethod("GET");
                    BufferedReader reader = new BufferedReader(
                            new InputStreamReader(conn.getInputStream()));
                    linie = reader.readLine();
                    reader.close();
                    resp += "ping: \t" + linie + "\n";

                    url = new URL(urlServ + "upcase?s=negru");
                    conn = (HttpURLConnection) url.openConnection();
                    conn.setRequestMethod("GET");
                    reader = new BufferedReader(new InputStreamReader(
                            conn.getInputStream()));
                    linie = reader.readLine();
                    reader.close();
                    resp += "upcase: \tnegru = " + linie + "\n";

                    url = new URL(urlServ + "upcase/negru");
                    conn = (HttpURLConnection) url.openConnection();
                    conn.setRequestMethod("POST");
                    conn.setRequestProperty("Content-Type", "application/xml");
                    conn.setRequestProperty("Content-Length", "0");
                    reader = new BufferedReader(new InputStreamReader(
                            conn.getInputStream()));
                    linie = reader.readLine();
                    reader.close();
                    resp += "upcase: \tnegru = " + linie + "\n";

                    url = new URL(urlServ + "add");
                    String body = "a=66&b=75";
                    conn = (HttpURLConnection) url.openConnection();
                    conn.setRequestMethod("PUT");
                    conn.setDoOutput(true);
                    conn.setDoInput(true);
                    conn.setRequestProperty("Content-Type",
                            "application/x-www-form-urlencoded");
                    conn.setRequestProperty("Content-Length",
                            "" + body.length());
                    Writer writer = new OutputStreamWriter(
                            conn.getOutputStream());
                    writer.write(body);
                    writer.close();
                    reader = new BufferedReader(new InputStreamReader(
                            conn.getInputStream()));
                    linie = reader.readLine();
                    reader.close();
                    resp += "add: \t66 + 75 = " + linie + "\n";

                    url = new URL(urlServ + "add/66/75");
                    conn = (HttpURLConnection) url.openConnection();
                    conn.setRequestMethod("DELETE");
                    conn.setRequestProperty("Content-Type", "application/xml");
                    conn.setRequestProperty("Content-Length", "0");
                    reader = new BufferedReader(new InputStreamReader(
                            conn.getInputStream()));
                    linie = reader.readLine();
                    reader.close();
                    resp += "add: \t66 + 75 = " + linie + "\n";

                    url = new URL(urlServ + "ping");
                    conn = (HttpURLConnection) url.openConnection();
                    conn.setRequestMethod("GET");
                    reader = new BufferedReader(new InputStreamReader(
                            conn.getInputStream()));
                    linie = reader.readLine();
                    reader.close();
                    resp += "ping: \t" + linie + "\n";
                    return resp;
                } catch (Exception e) {
                    StringWriter sw = new StringWriter();
                    PrintWriter pw = new PrintWriter(sw);
                    e.printStackTrace(pw);
                    return resp + "ERROR:\n" + sw.toString();
                }

            }

            @Override
            protected void onPostExecute(String res) {
                ((TextView) findViewById(R.id.res)).setText(res);
            }
        };
        task.execute("Execute");
    }
}
