using System;
using System.Net;
using System.IO;
using System.Text;
using System.Collections;
public class Rs1Clie {
    public Rs1Clie(String urlServ) {
        Console.WriteLine("Client: C# RESTful " + urlServ);
        Hashtable url = Hurl.hurl(urlServ);
        urlServ = "http://"+url["host"]+":"+url["port"]+"/"+url["path"]+"/";
        HttpWebRequest req = null;
        HttpWebResponse res = null;
        StreamReader reader = null;

        req = (HttpWebRequest)WebRequest.Create(urlServ + "ping");
        res = (HttpWebResponse)req.GetResponse();
        reader = new StreamReader(res.GetResponseStream());
        Console.WriteLine("ping: \t" + reader.ReadToEnd());

        req = (HttpWebRequest)WebRequest.Create(urlServ + "upcase?s=negru");
        res = (HttpWebResponse)req.GetResponse();
        reader = new StreamReader(res.GetResponseStream());
        Console.WriteLine("upcase: \tnegru = " + reader.ReadToEnd());

        req = (HttpWebRequest)WebRequest.Create(urlServ + "upcase/negru");
        req.Method = "POST";
        req.ContentType = "application/xml";
        req.ContentLength = 0;
        res = (HttpWebResponse)req.GetResponse();
        reader = new StreamReader(res.GetResponseStream());
        Console.WriteLine("upcase: \tnegru = " + reader.ReadToEnd());

        req = (HttpWebRequest)WebRequest.Create(urlServ + "add");
        req.Method = "PUT";
        byte[] body = Encoding.UTF8.GetBytes("a=66&b=75");
        req.ContentType = "application/x-www-form-urlencoded";
        req.ContentLength = body.Length;
        req.KeepAlive = true; // Pastreaza legatura ca sa poata trimite body
        Stream writer = req.GetRequestStream();
        writer.Write(body, 0, body.Length);
        writer.Close();
        res = (HttpWebResponse)req.GetResponse();
        reader = new StreamReader(res.GetResponseStream());
        Console.WriteLine("add: \t66 + 75 = " + reader.ReadToEnd());
    
        req = (HttpWebRequest)WebRequest.Create(urlServ + "add/66/75");
        req.Method = "DELETE";
        req.ContentType = "application/xml";
        req.ContentLength = 0;
        res = (HttpWebResponse)req.GetResponse();
        reader = new StreamReader(res.GetResponseStream());
        Console.WriteLine("add: \t66 + 75 = " + reader.ReadToEnd());

        req = (HttpWebRequest)WebRequest.Create(urlServ + "ping");
        res = (HttpWebResponse)req.GetResponse();
        reader = new StreamReader(res.GetResponseStream());
        Console.WriteLine("ping: \t" + reader.ReadToEnd());
    }
    public static void Main(String[] args) {
        if (args.Length > 0) new Rs1Clie(args[0]); 
//        else new Rs1Clie("http://172.30.0.14/~florin/Rs1Serv.ashx");  
        else new Rs1Clie("http://win.scs.ubbcluj.ro/~florin/Rs1Serv.ashx/");  
    }
}
