<%@ WebHandler language="C#" class="Rs1Serv" %>
using System;
using System.Net;
using System.Web;
using System.Collections;
using System.Collections.Specialized;
using System.IO;
public class Rs1Serv : IHttpHandler {
    public static String ping() {
        IPHostEntry host = Dns.GetHostEntry(Dns.GetHostName());
        return "C# RESTful "+host.HostName+
            " ("+host.AddressList[0]+":80) " + DateTime.Now;
    }
    public static String upcase(String s) {
        return s.ToUpper();
    }
    public static int add(int a, int b) {
        return a + b;
    }
    public bool IsReusable { get { return false; } }
    public void ProcessRequest(HttpContext ctx) {
        String[] apel = {"/ping", "/upcase?", "/upcase/", "/add/", "/add"}; 
        String url = ctx.Request.RawUrl.ToString().ToLower();
        int i=0, p=-1, a=0, b=0;
        for (i=0; i<apel.Length; i++) {
            p = url.IndexOf(apel[i]);
            if (p > 0) break;
        }
        switch (i) {
        case 0: 
            if (ctx.Request.HttpMethod != "GET") break;
            ctx.Response.Write(ping() + " method GET"); 
            break;
        case 1:
            if (ctx.Request.HttpMethod != "GET") break;
            ctx.Response.Write(upcase(url.Substring(p + 10)) + " method GET"); 
            break;
        case 2: 
            if (ctx.Request.HttpMethod != "POST") break;
            ctx.Response.Write(upcase(url.Substring(p + 8)) + " method POST"); 
            break;
        case 4:
            if (ctx.Request.HttpMethod != "PUT") break;
            Stream body = ctx.Request.InputStream;
            a = Convert.ToInt32(body.Length);
            byte[] bBody = new byte[a];
            body.Read(bBody, 0, a);
            String s = System.Text.Encoding.ASCII.GetString(bBody);
            a = int.Parse(s.Substring(2, s.IndexOf("&") - 2));
            b = int.Parse(s.Substring(s.IndexOf("&") + 3));
            ctx.Response.Write(add(a, b).ToString() + " method PUT"); 
            break;
        case 3: 
            if (ctx.Request.HttpMethod != "DELETE") break;
            a = int.Parse(url.Substring(p + 5, url.LastIndexOf("/") - p - 5));
            b = int.Parse(url.Substring(url.LastIndexOf("/") + 1));
            ctx.Response.Write(add(a, b).ToString() + " method DELETE");
            break;
        default: break;
        }
  }
}
