<?php
require_once ('RestClient.php');
require_once("Hurl.php");
class Rh1Clie {
    function __construct($urlServ) {
        echo "Client PHP RESTful " . $urlServ . "<br/>";
        $url = hurl($urlServ);
        $urlServ = "http://".$url["host"].":".$url["port"];
        if (strlen($url["path"]) > 0)
            $urlServ .= "/".$url["path"];
        $response = RestClient::get($urlServ."/ping");
        echo "ping: " . $response->getResponse()."<br/>";
        $response = RestClient::get($urlServ . "/upcase?s=negru");
        echo "upcase: negru = " . $response->getResponse() . "<br/>";
        $response = RestClient::post($urlServ . "/upcase/negru", null, null, null, "application/xml");
        echo "upcase: negru = " . $response->getResponse() . "<br/>";
        $response = RestClient::put($urlServ . "/add", "a=66&b=75", null, null, "application/x-www-form-urlencoded");
        echo "add: 66 + 75 = " . $response->getResponse() . "<br/>";
        $response = RestClient::delete($urlServ . "/add/66/75");
        echo "add: 66 + 75 = " . $response->getResponse() . "<br/>";
        $response = RestClient::get($urlServ."/ping");
        echo "ping: " . $response->getResponse()."<br/>";
    }
}
if (isset($_GET['urlServ'])) new Rh1Clie($_GET['urlServ']);
else new Rh1Clie("http://localhost/Rh1Serv.php");
?>
