import cherrypy
import sys
import socket
from datetime import datetime
import Hurl
class Ry1Serv:
    @cherrypy.expose
    def ping(self):
        if cherrypy.request.method == "GET": 
            name = socket.gethostname()
            ip = socket.gethostbyname(name)
            return "Python RESTful Ry1Serv.py " + " " + name + "(" +ip + ":" +\
                 `self.port` + "), " + `datetime.now()` + " method: GET"
    @cherrypy.expose
    def upcase(self, *args, **kwargs):
        if cherrypy.request.method == "GET": 
            return kwargs['s'].upper() + " method: GET"
        elif cherrypy.request.method == "POST":
            return args[0].upper() + " method: POST"
    @cherrypy.expose
    def add(self, *args, **kwargs):
        if cherrypy.request.method == "PUT": 
            return `(int(kwargs['a']) + int(kwargs['b']))` + " method: PUT"
        elif cherrypy.request.method == "DELETE": 
            return `(int(args[0]) + int(args[1]))` + " method: DELETE"
    def __init__(self, urlServ):
        url = Hurl.hurl(urlServ)
        self.port = int(url["port"])
        cherrypy.server.socket_port = self.port
        cherrypy.server.socket_host = url["host"]
        print "Python RESTful service waiting at:" + urlServ  
        cherrypy.quickstart(self)
if len(sys.argv) > 1: 
    Ry1Serv(sys.argv[1])
else:
    Ry1Serv("http://0.0.0.0:3004")
